/****************************************************************************

 This file is part of GLC-Player.
 Copyright (C) 2007-2008 Laurent Ribon (laumaya@users.sourceforge.net)
 Version 2.0.0, packaged on March 2009.

 http://www.glc-player.net

 GLC-Player is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 GLC-Player is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GLC-Player; if not, write to the Free Software
 Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

*****************************************************************************/

#ifndef ABOUTOPENGLVIEW_H_
#define ABOUTOPENGLVIEW_H_
#include <QGLWidget>
#include <GLC_Viewport>
#include <GLC_World>
#include <GLC_Light>
#include <GLC_Vector4d>
#include <QTimer>

class AboutOpenglView  : public QGLWidget
{
	Q_OBJECT
public:
	AboutOpenglView(QWidget *);

	virtual ~AboutOpenglView();

//////////////////////////////////////////////////////////////////////
// Public Set Functions
//////////////////////////////////////////////////////////////////////
public:

	//! Reframe to the world
	void reframeAll();

//////////////////////////////////////////////////////////////////////
// Protected services Functions
//////////////////////////////////////////////////////////////////////
private:
	//! Initialize OpenGL window
	void initializeGL();

	//! paint in the opengl widget
	void paintGL();

	//! The widget as been resized
	void resizeGL(int width, int height);
//////////////////////////////////////////////////////////////////////
// Private slots Functions
//////////////////////////////////////////////////////////////////////
private slots:
	//! Rotate the view
	void rotateView();
//////////////////////////////////////////////////////////////////////
// Private members
//////////////////////////////////////////////////////////////////////
private:
	//! The viewport
	GLC_Viewport m_GlView;

	//! The world
	GLC_World* m_pWorld;

	//! The Light
	GLC_Light m_Light;

	//! The timer used for motion
	QTimer m_MotionTimer;

	//! The rotation vector
	GLC_Vector4d m_RotationVector;

};

#endif /* ABOUTOPENGLVIEW_H_ */
